/*
 * ===========================
 * VDK Visual Development Kit
 * xdb subsystem
 * ===========================
 *
 * Copyright (C) 1998,2004, Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
#ifndef _vdkxparser_h
#define _vdkxparser_h

#include <vdkxdb/vdkxdb.h>
#include <vdkxdb/vdkxtable.h>
class VDKXParser
{

    protected:
        VDKXDatabase* xdb;
        VDKXTable* table;
        char type;
        char *expr;
    public:
        VDKXParser(VDKXDatabase* xdb,VDKXTable* table = NULL);
        virtual ~VDKXParser();
        xbShort Parse(char* opnd1, char* opr = NULL, char* opnd2 = NULL );
        char* Expression();
        char ResultType();
        int GetIntResult();
        double GetDoubleResult();
        const char* GetStringResult() ;
};
#endif

